<?php
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes/common_plugin.class.inc.php');

  /* 
      generic class for translator
        initialize plugin name and tables names list
  */
  class formattedDescription extends common_plugin
  {
    function formattedDescription($prefixeTable, $filelocation)
    {
      parent::common_plugin($prefixeTable, $filelocation);
      $this->plugin_name='FormattedDescription';
      $this->section_name=$this->plugin_name;
    }

    /*
      intialize default values 
    */
    function init_config()
    {
      //global $user;
      $this->my_config=array(
        'not_visible' => '<!--hidden-->'
      );
    }

    /*
      initialize events call for the plugin
    */
    function init_events()
    {
      add_event_handler('loc_begin_index_category_thumbnails',
                        array(&$this, 'apply_filter'),
                        EVENT_HANDLER_PRIORITY_NEUTRAL+1
      );
      add_event_handler('render_category_description',
                        array(&$this, 'modify_desc'),
                        EVENT_HANDLER_PRIORITY_NEUTRAL+2,2);
    }


    /* ---------------------------------------------------------------------------
      base functions
    --------------------------------------------------------------------------- */

    function apply_filter($tmp)
    {
      global $categories, $hidden_cat;
      $i=0;
      while($i<count($categories))
      {
        if(strpos($categories[$i]['name'], $this->my_config['not_visible'])!==false)
        {
          array_splice($categories,$i,1);
        }
        else
        {
          $i++;
        }
      }
    }

    function modify_desc($desc, $param='')
    {
      global $user, $page, $category, $hidden_cat;

      preg_match_all('/\[cat=(\d*)\]/i', $desc,$desc_lst, PREG_PATTERN_ORDER);
      for($i=0;$i<count($desc_lst[0]);$i++)
      {
        $desc_lst[0][$i]= '/\[cat='.$desc_lst[1][$i].'\]/i';
        $desc_lst[1][$i] = $this->get_cat_thumb($desc_lst[1][$i]);
      }

      preg_match_all('/\[img=([\d\.]*)(?:;left|;right|)\]/i', $desc,$desc_lst2, PREG_PATTERN_ORDER);
      for($i=0;$i<count($desc_lst2[0]);$i++)
      {
        preg_match('/\[img=(?:[\d\.]*)[;]?(left|right|)\]/i', $desc_lst2[0][$i], $tmp);
        $desc_lst[0][]= '/\[img='.$desc_lst2[1][$i].'(?:;left|;right|)\]/i';
        $desc_lst[1][] = $this->get_img_thumb($desc_lst2[1][$i], $tmp[1]);
      }

      $desc=preg_replace($desc_lst[0],$desc_lst[1], $desc);

      return($desc);
    }


    function get_cat_thumb($elem_id)
    {
      global $user;
      $local_tpl = new Template(FORMATTEDDESCRIPTION_PATH, "");
      $local_tpl->set_filename('thumbnails', dirname($this->filelocation)."/template/cat.tpl");

      $sql="SELECT
              ".CATEGORIES_TABLE.".id, ".CATEGORIES_TABLE.".name, ".CATEGORIES_TABLE.".permalink,
              ".CATEGORIES_TABLE.".representative_picture_id, ".CATEGORIES_TABLE.".comment,
              ".CATEGORIES_TABLE.".nb_images, ".CATEGORIES_TABLE.".uppercats,
              ".CATEGORIES_TABLE.".date_last,  ".CATEGORIES_TABLE.".global_rank,
              ".IMAGES_TABLE.".path, ".IMAGES_TABLE.".tn_ext
            FROM ".CATEGORIES_TABLE.", ".IMAGES_TABLE."
            WHERE ".CATEGORIES_TABLE.".id = ".$elem_id."
              AND ".IMAGES_TABLE.".id = ".CATEGORIES_TABLE.".representative_picture_id";

      $result=pwg_query($sql);
      if($result)
      {
        while($category=mysql_fetch_array($result))
        {
          $local_tpl->assign_vars(
            array(
              'SRC' => get_thumbnail_url($category),
              'ALT' => $category['name'],
              'URL' => make_index_url(
                                  array(
                                    'category' => $category
                                    )
                                  ),
              'NAME' => $category['name'],
              'CAPTION_NB_IMAGES'  => get_display_images_count(
                                        $category['nb_images'],
                                        $category['nb_images'],
                                        0,
                                        true,
                                        '<br />'
                                      ),
              'DESCRIPTION' => trigger_event('render_category_literal_description',
              trigger_event('render_category_description',
                @$category['comment'],
                'subcatify_category_description'))
            )
          );
        }
        $returnedhtml=$local_tpl->parse('thumbnails', true);
      }
      else
      {
        $returnedhtml="";
      }

      $local_tpl->destroy();

      return($returnedhtml);
    }

    function get_img_thumb($elem_id, $align="")
    {
      global $user;
      $local_tpl = new Template(FORMATTEDDESCRIPTION_PATH, "");
      $local_tpl->set_filename('thumbnails', dirname($this->filelocation)."/template/img.tpl");

      if(strpos($elem_id, '.')!==false)
      {
        $tmp=explode('.', $elem_id);
      }
      else
      {
        $tmp[0]=$elem_id;
        $tmp[1]='';
      }

      $sql="SELECT *
            FROM ".IMAGES_TABLE."
            WHERE ".IMAGES_TABLE.".id = ".$tmp[0];

      $result=pwg_query($sql);
      if($result)
      {
        while($picture=mysql_fetch_array($result))
        {
          $local_tpl->assign_vars(
            array(
              'IMAGE'       => get_thumbnail_url($picture),
              'IMAGE_ALT'   => $picture['name'],
              'U_IMG_LINK'  => make_picture_url(
                                  array(
                                    'image_id' => $picture['id'],
                                    'category' => array('id' => ($tmp[1]!='')?$tmp[1]:$picture['storage_category_id'])
                                    )
                                  ),
              'CLASS' => 'thumbCat',
              'FLOAT' => ($align!="")?"float:".$align.";":""
            )
          );
          $local_tpl->assign_block_vars(
          'comment_block',
          array(
            'NAME' =>  $picture['name']
            )
          );
        }
        $returnedhtml=$local_tpl->parse('thumbnails', true);
      }
      else
      {
        $returnedhtml="";
      }

      $local_tpl->destroy();

      return($returnedhtml);
    }



  } //class

?>
